#ifndef _CMDLINE_H_

#define _CMDLINE_H_
#include "configuration.h"

#ifdef USE_CMDLINE

#define CMDLINE_VERSION               0x06
#define ERRC_OK        0
#define ERRC_CMD_LINE_GET_NUMBER_ERR        0x10
#define ERRC_CMD_LINE_GET_PARAMETERS        0x20
#define ERRC_CMD_LINE_HANDLER_ERR           0x30
#define ERRC_CMD_LINE_REGISTER_CMD_ERR      0x40
#define ERRC_INVALID_PARAMETER       0x3
#define ERRC_INVALID_PARAMETER_NUMBER 0x4
#define ERRC_INVALID_STRING_LENGTH   0x5
#define ERRC_COMMAND_NOT_FOUND       0x6
#define ERRC_TOO_MANY_COMMANDS       0x7
#define ERRC_COMMAND_ALREADY_EXIST   0x8
#define ERRC_INVALID_COMMAND_LENGTH  0x9
#define ERRC_INVALID_PARAMETER_LENGTH 0xa
#define ERRC_INVALID_PARAMETER_TYPE  0xb
#define ERRC_FALSE	0xFF


#define MAX_COMMANDS 10
#define MAX_STRING_LENGTH 128

extern unsigned char rxData;	/* Byte received from DBG terminal */

typedef union {
    int       d;      //binary, decimal or hexadecimal
    unsigned  x;      //hexadecimal, for backward compatibility
    char      s[MAX_STRING_LENGTH];
  } tPar;


typedef unsigned char tCallBack0(tPar *pPar, unsigned char ucParNum, unsigned char ucSwitch);

typedef struct {
   char *pCmdName;
   unsigned char ucCmdNameLength;
   char *pCmdPar;
   unsigned char ucCmdParLength;
   tCallBack0 *pCallBack;
   unsigned char ucSwitch;
} tCOMMAND; 
//===( Functions )==============================================================

void CmdLine_Init(void);

//------------------------------------------------------------------------------
//  D ate: 26-Mar-2007
//  Author: RK
//  Description:
//    return: 32bit Command Line Version
//------------------------------------------------------------------------------
unsigned char CmdLine_GetVersion();

//------------------------------------------------------------------------------
//  Date: 26-Mar-2007
//  Author: RK
//  Description:
//    return: ERRCODE (0=OK)
//------------------------------------------------------------------------------
unsigned char CmdLineHandler();
unsigned char CmdLine_SaveByte(unsigned char ucByte);

//------------------------------------------------------------------------------
//  Date: 26-Mar-2007
//  Author: RK
//  Description:
//    return: ERRCODE (0=OK)
//------------------------------------------------------------------------------
unsigned char CmdLine_RegisterCmd( char *pCmdName, 
                                 //   unsigned char ucCmdNameLength,
                                    char *pCmdPar,
                                   // unsigned char ucCmdParLength,
                                    tCallBack0 *pCallBack,
                                    unsigned char ucSwitch);

#endif
#endif
