/**
  ******************************************************************************
  * @file           : hallsense.c
  * @brief          : Hall Sensor Driver
  * @author			: ELKYS servis s.r.o. (2019)
  ******************************************************************************
  * Redistribution and use in source and binary forms, with or without modification,
  * are permitted provided that the following conditions are met:
  *   1. Redistributions of source code must retain the above copyright notice,
  *      this list of conditions and the following disclaimer.
  *   2. Redistributions in binary form must reproduce the above copyright notice,
  *      this list of conditions and the following disclaimer in the documentation
  *      and/or other materials provided with the distribution.
  *   3. Neither the name of ELKYS servis s.r.o.  nor the names of its contributors
  *      may be used to endorse or promote products derived from this software
  *      without specific prior written permission.
  *
  * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
  * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
  * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
  * DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE
  * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
  * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
  * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
  * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
  * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  *
  ******************************************************************************
  */
#include "hallsense.h"

HALLSENSEInfo_TypeDef HALLSENSE;
#define HALLSENSE_STATE HAL_GPIO_ReadPin(HALLSENSE.GPIO_Port, HALLSENSE.GPIO_Pin)

void HALLSENSE_Init(GPIO_TypeDef* GPIOx, uint16_t GPIO_Pin)
{
	HALLSENSE.GPIO_Port = GPIOx;
	HALLSENSE.GPIO_Pin = GPIO_Pin;
	HALLSENSE.State = HALLSENSE_STATE;
	HALLSENSE.Changed = 0;
}

void HALLSENSE_ReadState(void)
{
	GPIO_PinState state = HALLSENSE_STATE;
	if (state == HALLSENSE.State) return;
	HALLSENSE.State = state;
	HALLSENSE.Changed = 1;
}

void HALLSENSE_Handler(void)
{
	if (HALLSENSE.Changed == 1)
	{
		HALLSENSE.Changed = 0;
		printf("Hall Sensor State: %d\r\n", (uint8_t)HALLSENSE.State);
		if ( HALLSENSE.State == 0) SLEEPMODE_GotoSTOP2();

	}
}

